/* Event Booking Pro - WordPress Plugin
 * Form Manager Addon
 * Get plugin at: http://iplusstd.com/item/eventBookingPro/
 * Author Moe Haydar
 */


(function($){
$(document).ready(function(){

	//Button Events
	$(".formsList li a").click(function(e) {
		formBtnClicked($(this))
  });

	// add
	$('#newForm').click(function(e){
		e.preventDefault();
		var newId = Number($("#maxFormID").val()) + 1;
		$("#maxFormID").val(newId);
		var html = '<li id="form_' + newId + '"><a href="#" data-id="' + newId + '" class="btnE btn-block "><span>Form Name</span></a></li>';
		$(".formsList li a.active").removeClass("active");
		$('.formsList').append(html);
		$("#form_" + newId).find("a").addClass("active");

		$(".formsList li:last-child a").click(function(e) {
			formBtnClicked($(this))
		});

		prepareDetails(newId,{
			id: newId,
			name :"Form Name",
			fields:"",
			splitName: false,
			firstNameTxt: "First Name",
			lastNameTxt: "Last Name"
		});
	});

	function formBtnClicked($which){
		$(".formsList li a.active").removeClass("active");
		$which.addClass("active");
		getDetails($which.attr("data-id"));
	}

	function getDetails(id){
		prepareDetails(id,["load"])
	}

	function prepareDetails(id,data){
		var html='<input type="hidden" id="formID" value="' + id + '"/>';
		$('.formsDetailsCnt .cnt').html(html);
		if(data[0] == "load") {
			getFormDetails();
		} else {
			getDetailEditsMarkUp(id,data);
			saveForm();
		}
	}

	var hasCharegableInputs = $('#hasCharegableInputs').val() == 'true';

	function getFormDetails(){
		var id = $("#formID").val();
		$('#loader').slideDown(100);
		$.ajax({
			type:'POST',
			url: 'admin-ajax.php',
			data:'action=form_fetch&id=' + id,
			success: function(response) {
				$('#loader').slideUp(100);
				var data = $.parseJSON(response)
				getDetailEditsMarkUp(id,data)
			}
		});
	}

	var FieldTypes = {
		text: ["Text Field", "txt", 1],
		textArea: ["Text Area", "txtArea", 1],
		email:["Email Address Field", "email", 1],
		checkBox:["Check Box", "check", 2],
		selectBox:["Select Field", "select", 2],
		radioButtons:["Radio Buttons", "radio", 2],
		terms:["Terms & Condition", "terms", 3],
		staticText: ["Static Text", "staticText", 4],

		checkBox_fee:["Check Box (with fee)", "check_fee", 6],
		selectBox_fee:["Select Field (with fee)", "select_fee", 6],
		radioButtons_fee:["Radio Buttons (with fee)", "radio_fee", 6]

	};


	function getDetailEditsMarkUp(id, data){
		html = '<form id="formDetails" class="formDetails" method="post">'

		html += '<div class="head"><span>Name: </span><input id="name" name="name" value="' + data.name.replace(/\\/g, '') + '" type="text"  /></div>'
		html += '</div>'

		html += '<div class="formElements">';
		html += "<h2>Form Fields:</h2>";
		html += "<div class='alert alert-success'>Name and Email fields will always be included in any form, so you do not need to add them!";

			html += '<div class="splitNameCnt">';
				var checked = (data.splitName=='true')?'checked': '';
				html += '<input type="checkbox" id="splitName" '+checked+'><label for="splitName">Split name field into 2 fields (firstname and lastname)</label>';
				var show = (data.splitName=='true') ? '': 'style="display:none"'
				html += '<div class="namePlaceHolders" ' + show + '>"First Name" placeholder text: <input type="text" id="firstNameTxt" placeholder="First Name placeholder text" value="'+data.firstNameTxt+'"></div>';
				html += '<div class="namePlaceHolders" ' + show + '>"Last Name" placeholder text: <input type="text" id="lastNameTxt" placeholder="Last Name placeholder text"  value="'+data.lastNameTxt+'"></div>';
			html += '</div>';
		html += "</div>";


		html += '<div class="formFields">';

		var fields = data.fields.split("|");

		var subData, Type;
		for (var i = 0; i < fields.length; i++ ) {
			subData = fields[i].split(',');

			if (subData != "") {
				switch(subData[1]){
					case "txt":
						Type = FieldTypes.text;
						break
					case "txtArea":
						Type = FieldTypes.textArea;
						break
					case "email":
						Type = FieldTypes.email;
						break
					case "check":
						Type = FieldTypes.checkBox;
						break
					case "select":
						Type = FieldTypes.selectBox;
						break
					case "radio":
						Type = FieldTypes.radioButtons;
						break;
					case "terms":
						Type = FieldTypes.terms;
						break;
					case "staticText":
						Type = FieldTypes.staticText;
						break;

					case "check_fee":
						Type = FieldTypes.checkBox_fee;
						break
					case "select_fee":
						Type = FieldTypes.selectBox_fee;
						break
					case "radio_fee":
						Type = FieldTypes.radioButtons_fee;

				}
				html  += getField(subData[0], Type, false, subData);
			}
		}
		//
		html +=  '</div>';
		html += '<a href="#" class="addField">Add new field</a>';

		if (hasCharegableInputs)
			html += '<a href="#" class="addField fee">Add new fee-able field</a>'; // fee

		html += '</div>';

		html += ' <div class="btns"><a href="#" class="btn btn-small btn-success btn-save">Save</a><a href="#" class="btn btn-small btn-duplicate btn-primary">Duplicate</a> <a href="#" class="btn btn-small btn-danger btn-delete">Delete</a></div>'
		html += ' </form><br class="ev-clear"/>'


		$(".formsDetailsCnt .cnt").append(html);

		$('#splitName').change(function() {
	    if($(this).is(":checked")) {
	      $(this).parent().find('.namePlaceHolders').show();
	    } else {
	    	$(this).parent().find('.namePlaceHolders').hide();
	    }
	  });


		$( ".formFields" ).sortable({
		  connectWith: ".formFields",
		  handle: ".header"
		});

	}

	$('.btn-duplicate').live('click', function(e){
		e.preventDefault();
		duplicateForm($('#formDetails #name').val());
	});

	function duplicateForm(name){
		var newId = Number($("#maxFormID").val()) + 1;
		$("#maxFormID").val(newId);

			var html = '<li id="form_' + newId + '"><a href="#" data-id="' + newId + '" class="btn btn-block "><span>Form Name</span></a></li>';
		$(".formsList li a.active").removeClass("active");
		$('.formsList').append(html);
		$("#form_" + newId).find("a").addClass("active");


		$('#formID').val(newId);
		$(".formFields .fieldCnt").each(function(index, element) {
           $(this).attr("data-id","-1");
        });

		saveForm();
		window.scrollTo(0,0);
	}

	$(".md-content .option").live('click',  function(e) {
		e.preventDefault();

		$( '.md-show' ).removeClass('md-show' );
		$(document).removeClass( 'md-perspective' );

		$('html, body').animate({
			scrollTop: $(".addField").offset().top
		}, 200);

		var newHtml = "";

		switch($(this).attr("data-type")){
			case "text":
				newHtml = getField(-1, FieldTypes.text, true, []);
			break;

			case "textarea":
				newHtml = getField(-1, FieldTypes.textArea, true, []);
			break;

			case "email":
				newHtml = getField(-1, FieldTypes.email, true, []);
			break;

			case "checkbox":
				newHtml = getField(-1, FieldTypes.checkBox, true, []);
			break;

			case "select":
				newHtml = getField(-1, FieldTypes.selectBox, true, []);
			break;

			case "radio":
				newHtml = getField(-1, FieldTypes.radioButtons, true, []);
				break;

			case "terms":
				newHtml = getField(-1, FieldTypes.terms, true, []);
				break;

			case "staticText":
				newHtml = getField(-1, FieldTypes.staticText, true, []);
				break;

			case "checkbox_fee":
				newHtml = getField(-1, FieldTypes.checkBox_fee, true, []);
			break;

			case "select_fee":
				newHtml = getField(-1, FieldTypes.selectBox_fee, true, []);
			break;

			case "radio_fee":
				newHtml = getField(-1, FieldTypes.radioButtons_fee, true, []);
				break;


		}
		$(".formsDetailsCnt .formFields").append(newHtml);
	});

	$('.addField').live('click', function(e) {
		e.preventDefault();
		if ($(this).hasClass('fee') && hasCharegableInputs) {
			openChargeableFieldChooser();
		} else {
			openFieldChooser();
		}
	});

	$('.formFields input').live('focus',function() {
		$(this).css("border-color","#ddd");
	});

	$('.formFields .header').live('click', function(e){
		$(this).parent().find(".cnt").toggle();
	});

	$('.formFields .delete').live('click', function(e){
		$(this).parent().parent().parent().remove();
	});

	$('.btn-delete').live('click', function(e){
		e.preventDefault();
		deleteData();
	});

	$('.btn-save').live('click',function(e){
		e.preventDefault();
		saveForm();
	});

	var addItemHTML = function (item_name, hasPrice, item_price) {

		var item = '<div class="input_item">';
		item += '<input type="text" name="itemName" value="' + item_name + '" placeholder="option name" />';

		if (hasPrice) item += '<input name="itemCost" type="number" min="0" value="' + item_price + '"  placeholder="cost"/>';

		item += '<a href="#" class="close item_close_btn">x</a>';
		item += '</div>';
		return item;
	}

	function getField (id,type,isOpen,subData) {

		if (subData.length < 5) {
			subData = ['', '', '', '', '', '', '', ''];
		}

		var show = (!isOpen) ? 'style="display:none;"' : '';

		var html = '<div class="fieldCnt" data-type="' + type[1] + '" data-id="' + id + '">';
				html += '<div class="header"><h3>' + type[0] + '<div class="toggle delete">x</div></h3></div>';
				html += '<div class="cnt" ' + show + '><form>';
				if (type[2] == 4) {
					html += '<div class="option"><span>Text:</span><input type="text" value="' + subData[3] + '" name="textToDisplay" /></div>';

					if (!subData[4]) subData[4] = 16;
					html += '<div class="option"><span>Font size:</span><input type="number" value="' + subData[4] + '" name="fontSize" /></div>';

				} else if (type[2] == 3) {
					html += '<div class="option"><span>Text to display:</span><input type="text" value="' + subData[3] + '" name="textToDisplay" /></div>';
					html += '<div class="option"><span>Links to Terms & Conditions:</span><input type="text" value="' + subData[4] + '" name="link" /></div>';

				} else {


					html += '<div class="option"><span>name*:</span><input type="text" value="' + subData[3] + '" name="name" /><a href="#" class="tip-below tooltip" data-tip="This is for your own reference! Must be unique.">?</a></div>';

					html += '<div class="option"><span>Label:</span><input type="text" value="' + subData[4] + '" name="label" /><a href="#" class="tip-below tooltip" data-tip="Text to show beside a field">?</a></div>';

					if (type[2] == 1){
						html += '<div class="option"><span>PlaceHolder text:</span><input type="text" value="' + subData[6] + '" id="placeholder" name="placeholder" /></div>';
					} else {
						var isFeeable = type[2] == 6 && hasCharegableInputs;
						var dataIsFeeable = (isFeeable) ? ' data-feeable="true" ' : '';

						html += '<div class="option itemCnt" ' + dataIsFeeable + '>';
							html += '<span>options:</span>';

							subData[6] = subData[6].trim().replace(/(\r\n|\n|\r)/gm, " ");
							subData[7] = subData[7].trim().replace(/(\r\n|\n|\r)/gm, " ");

							var itemsObj = subData[6].split(';');


							var itemsCost = (isFeeable && subData[7]) ? subData[7].split(';') : [];

							var itemCost;
							for (var i = 0; i < itemsObj.length; i++) {
								if (itemsObj[i] == '') continue
								itemCost = parseInt(itemsCost[i]);
								if (!itemCost || itemCost < 1) itemCost = 0;

								html += addItemHTML(itemsObj[i].trim(), isFeeable, itemCost)
							}

						html += '<a href="#" class="add_option_item" ' + dataIsFeeable + '>Add option</a>';
						html += '</div>'

					}

					if (subData[5] == "true") {
						html += '<div class="option"><span>Required:</span><input type="checkbox" value="true" checked="checked" name="required" /></div>';
					} else {
						html += '<div class="option"><span>Required:</span><input type="checkbox" value="true" name="required" /></div>';
					}

					if (type[2] == 6 && hasCharegableInputs) {
						var feeTypeIsOnce = 'checked="checked"';
						var feeTypeIsTicket = '';
						if (subData[8] == 'ticket') {
							feeTypeIsTicket = feeTypeIsOnce;
							feeTypeIsOnce = '';
						}

						html += '<div class="option padded"><span>Fee type:</span>';
							html += '<input type="radio" value="once"  name="feeType"  ' + feeTypeIsOnce + '> Once';
							html += '<input style="margin-left: 5px;" type="radio" value="ticket" name="feeType" ' + feeTypeIsTicket + '> Per ticket';

							html += '<a href="#" style="margin-left:10px;" class="tip-above tooltip" data-tip="\'Once\' will charge the amount once without taking number of tickets into consideration. \'Per ticket\' will multiple amount of option by quantity booked. ">?</a>';
						html += '</div>';
					}
				}

				html += '</form></div>';
			html += '</div>';

		return html;
	}

	function openFieldChooser () {
		$modal = $('#fieldChooser')
		$modal.addClass('md-show' );
		setTimeout(function() {
			$('.md-content .offlineloader').hide();
				$(document).addClass('md-perspective');
			}, 25);
	}



	$(document).on('click', '.item_close_btn', function(e) {
		e.preventDefault();
		$(this).parent().remove();
	});

	$(document).on('click', '.add_option_item', function(e) {
		e.preventDefault();

		var isfee = $(this).attr('data-feeable') == 'true';

		$(this).before(addItemHTML('', isfee, ''));
	});



	$(document).on('click', 'a.md-close', function(e) {
		$modal.removeClass('md-show');
		$(document).removeClass('md-perspective');
	});

	// fee
	function openChargeableFieldChooser () {
		$modal = $('#chargableFieldChooser')
		$modal.addClass('md-show' );
		setTimeout(function() {
			$('.md-content .offlineloader').hide();
				$(document).addClass('md-perspective');
			}, 25);
	}



	function deleteData(){
		var id = $("#formID").val()
		$('#loader').slideDown(100);
		$.ajax({
			type:'POST',
			url: 'admin-ajax.php',
			data:'action=form_delete&id=' + id,
			success: function(response) {
				$('#loader').slideUp(100);
			}
		});

		$("#form_" + id).remove();
		$(".formsDetailsCnt .cnt").empty();
	}

	function saveForm (){
		var extras = "";
		var order = 1;
		var type, name, flag = false;

		$(".formFields>div").each(function(index, element) {
      type = $(this).attr("data-type");
			name = $(this).find('input[name="name"]').val();
			if(name == ""){
				flag = true;
				$(this).find('input[name="name"]').css("border-color","#F00");
				return false;
			}

			extras += $(this).attr("data-id");
			extras += "," + type
			extras += "," + order

			if (type === 'staticText') {
				extras += "," + $(this).find('input[name="textToDisplay"]').val();
				extras += "," + $(this).find('input[name="fontSize"]').val();
				extras += ",false"
			} else	if (type === 'terms') {
				extras += "," + $(this).find('input[name="textToDisplay"]').val();
				extras += "," + $(this).find('input[name="link"]').val();
				extras += ",true"
			} else {
				extras += "," + name
				extras += "," + $(this).find('input[name="label"]').val();

				if ($(this).find('input[name="required"]').is(':checked')) {
					extras += ",true"
				} else {
					extras += ",false"
				}

				if (type === 'txt' || type === 'txtArea') {
					extras += "," + $(this).find('#placeholder').val();
				} else {

					var currentItems = '';
					var currentCosts = '';
					var currName;
					var currCost;
					$(this).find('.itemCnt .input_item').each(function () {
						currName = $(this).find('input[name="itemName"]').val().trim();
						currCost = $(this).find('input[name="itemCost"]').val();

						if (currName !== '') {
							if (!currCost || currCost < 0) currCost = 0;
							if (currentItems != '') {
								currentItems += ';'
								currentCosts += ';'
							}

							currentItems += currName
							currentCosts += currCost;
						}
					});

					if ($(this).find('.itemCnt').attr('data-feeable') !== 'true')  currentCosts = '';

					extras += "," + currentItems;


					if (hasCharegableInputs) {
						extras += ","
						extras += currentCosts;
						extras += ","

						if ($(this).find('input[name="feeType"]:checked')) {
							extras += $(this).find('input[name="feeType"]:checked').val()
						} else {
							extras += "none"
						}

					} else {
						extras += ",,none";
					}

				}


			}
			extras += "|"
			order++ ;
    });


		if (flag) return;


		$('#loader').slideDown(100);

		var id = $('#formID').val();
		var name = $('#formDetails #name').val();

		var splitName = ($('#formDetails #splitName').is(':checked')) ? 'true' : 'false';
		var firstNameTxt = $('#formDetails #firstNameTxt').val();
		var lastNameTxt = $('#formDetails #lastNameTxt').val();

		$.ajax({
			type:'POST',
			url: 'admin-ajax.php',
			data:'action=form_save&id='  + id + '&name=' + encodeURIComponent(name)+
			'&splitName=' + splitName + '&firstNameTxt=' + firstNameTxt + '&lastNameTxt=' + lastNameTxt +
			'&extras=' + encodeURIComponent(extras),
			success: function(response) {
				$("#form_" + id).find("span").html(name);
				$('#loader').slideUp(100);

			}
		});
	}
})
})(jQuery)

